package com.njcn.device.pms.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.device.pms.api.PmsGeneratrixClient;
import com.njcn.device.pms.pojo.dto.GeneratrixAndPowerStationDTO;
import com.njcn.device.pms.pojo.dto.PmsGeneratrixDTO;
import com.njcn.device.pms.pojo.param.PmsGeneratrixParam;
import com.njcn.device.pms.utils.PmsDeviceEnumUtil;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author yzh
 * @date 2022/10/18
 */
@Slf4j
@Component
public class PmsGeneratrixClientFallbackFactory implements FallbackFactory<PmsGeneratrixClient> {
    @Override
    public PmsGeneratrixClient create(Throwable throwable) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (throwable.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) throwable.getCause();
            exceptionEnum = PmsDeviceEnumUtil.getExceptionEnum(businessException.getResult());
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new PmsGeneratrixClient() {
            @Override
            public HttpResult<List<PmsGeneratrixDTO>> getGeneratrixInfo(PmsGeneratrixParam pmsGeneratrixParam) {
                log.error("{}异常，降级处理，异常为：{}", "获取母线信息", throwable.toString());
                throw new BusinessException(finalExceptionEnum);
            }
            @Override
            public HttpResult<List<GeneratrixAndPowerStationDTO>> getGeneratrixAndPowerStationInfo(PmsGeneratrixParam param) {
                log.error("{}异常，降级处理，异常为：{}", "获取母线与电站关联信息", throwable.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
